﻿/*
 * Created by SharpDevelop.
 * User: jms
 * Date: 2019/7/23
 * Time: 上午 09:20
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Text;
using System.Web;
using System.Threading;
using System.Data;
using ZXing;                  // for BarcodeWriter //2019/07/26
using ZXing.QrCode;           // for QRCode Engine //2019/07/26
using System.Management;  //2019/07/27

namespace CSWebCGISvr
{
    /// <summary>
    /// Description of MainForm.
    /// </summary>
    public partial class MainForm : Form
    {
        private static readonly object LockFile = new object(); //寫 log 時鎖定判斷之用
        private static DataTable MemDataset1 = new DataTable("MemDataset1");



        public MainForm()
        {
            //
            // The InitializeComponent() call is required for Windows Forms designer support.
            //
            InitializeComponent();

            //
            // TODO: Add constructor code after the InitializeComponent() call.
            //
        }


        void MainFormLoad(object sender, EventArgs e)
        {
            _SaveLog("●程式啟動");


            //remark on 2019/07/26
            //this.Text = this.Text + " (" + Dns.GetHostEntry("localhost").AddressList[0] + ")";

            //2019/07/26 ->
            //this.Text = "http://192.168.0.14:8080/" ; //192.168.0.14


            //2019/07/27
            string local_ip = GetNetworkConfig();
            textBox1.Text = "http://" + local_ip + ":8080/";


            var writer = new BarcodeWriter  //dll裡面可以看到屬性
            {
                Format = BarcodeFormat.QR_CODE,
                Options = new QrCodeEncodingOptions //設定大小
                {
                    Height = 300,
                    Width = 300,
                }
            };
            pictureBox1.Image = writer.Write(textBox1.Text); //轉QRcode的文字
                                                             //2019/07/26 <-



            backgroundWorker1.WorkerReportsProgress = true; //才能用 ProgressChanged() 方法
            backgroundWorker1.RunWorkerAsync();

            richTextBox1.Multiline = true;     //
            richTextBox1.ScrollBars = RichTextBoxScrollBars.Vertical;

            //建立 MemDataset1 資料結構
            //http://sharp-csharp.blogspot.com/2012/02/how-to-create-in-memory-dataset-or.html
            MemDataset1.Columns.Add("InstanceID", typeof(string));
            MemDataset1.Columns.Add("BarcodeID", typeof(string));
            MemDataset1.Columns.Add("PluName", typeof(string));
            MemDataset1.Columns.Add("unitPrice", typeof(int));
            MemDataset1.Columns.Add("qty", typeof(int));
            MemDataset1.Columns.Add("salePrice", typeof(int));


        }


        //2019/07/27
        //References -> Add Reference -> System.Management
        private string GetNetworkConfig()
        {
            string rv = "";

            ManagementClass mc = new
            ManagementClass("Win32_NetworkAdapterConfiguration");
            ManagementObjectCollection nics = mc.GetInstances();
            foreach (ManagementObject nic in nics)
            {
                if (Convert.ToBoolean(nic["ipEnabled"]) == true)
                {
                    string IpAddress = (nic["IPAddress"] as String[])[0];
                    string IPSubnet = (nic["IPSubnet"] as String[])[0];
                    //string DefaultGateWay = (nic["DefaultIPGateway"] as String[])[0];

                    string DefaultGateWay = "";

                    try
                    {
                        DefaultGateWay = (nic["DefaultIPGateway"] as String[])[0];  //VM 的 ip 都沒有 DefaultGateWay. 所以要跳過
                        rv = IpAddress;
                    }
                    catch (Exception)
                    {
                        //throw;
                    }

                }
            }

            return rv;
        }



        void BackgroundWorker1DoWork(object sender, System.ComponentModel.DoWorkEventArgs e)
        {
            HttpListener listener = new HttpListener();
            try
            {
                //_存取被拒處理 : netsh http add urlacl url=http://*:8080/ user=everyone            	
                listener.Prefixes.Add("http://*:8080/"); //要監聽的URL範圍 ///windows 10 下出現 "存取被拒"
                                                         //listener.Prefixes.Add("http://localhost:8080/");  //windows 10 下要用這樣
                                                         //listener.Prefixes.Add("http://127.0.0.1:8080/"); 

                listener.Start(); //開始監聽端口，接收客户端請求
                //Console.WriteLine("Listening");
                while (true)
                {
                    //獲取一個客户端請求為止
                    HttpListenerContext context = listener.GetContext();
                    //將其處理過程放入線程池(Pool)
                    System.Threading.ThreadPool.QueueUserWorkItem(ProcessHttpClient, context);
                }
            }
            catch (Exception ee)
            {

                //Console.WriteLine(e.Message);
                MessageBox.Show(ee.Message);
            }
            finally
            {
                listener.Stop(); //關閉HttpListener
            }

        }
        void MainFormFormClosed(object sender, FormClosedEventArgs e)
        {
            if (backgroundWorker1.WorkerSupportsCancellation == true)
            {
                backgroundWorker1.CancelAsync();
            }
        }


        //客户請求處理
        void ProcessHttpClient(object obj)
        {
            HttpListenerContext context = obj as HttpListenerContext;
            HttpListenerRequest request = context.Request;
            HttpListenerResponse response = context.Response;

            _SaveLog("Call ProcessHttpClient() Start ...");



            //調用ProgressChanged改變form元件數值 否則無法跨執行緒執行(刷新UI動作)
            //backgroundWorker1.ReportProgress(0); //richTextBox1.Clear;

            backgroundWorker1.ReportProgress(1, "[request.Headers]");
            backgroundWorker1.ReportProgress(1, request.Headers.ToString());

            backgroundWorker1.ReportProgress(1, "[request.RawUrl]");
            backgroundWorker1.ReportProgress(1, request.RawUrl);

            _SaveLog("request.RawUrl=" + request.RawUrl);

            backgroundWorker1.ReportProgress(1, "[request.AcceptTypes]");
            backgroundWorker1.ReportProgress(1, string.Join("\n", request.AcceptTypes)); //strings[]->string 用 string.Join("\n", request.AcceptTypes)

            backgroundWorker1.ReportProgress(1, "[request.HttpMethod]");
            backgroundWorker1.ReportProgress(1, request.HttpMethod);

            _SaveLog("request.HttpMethod=" + request.HttpMethod);

            backgroundWorker1.ReportProgress(1, "[request.Url.Query]");
            backgroundWorker1.ReportProgress(1, request.Url.Query);

            backgroundWorker1.ReportProgress(1, "[request.QueryString]");
            backgroundWorker1.ReportProgress(1, request.QueryString.ToString());

            backgroundWorker1.ReportProgress(1, "[ContentType]");
            backgroundWorker1.ReportProgress(1, request.ContentType);

            backgroundWorker1.ReportProgress(1, "[request.UserAgent]");
            backgroundWorker1.ReportProgress(1, request.UserAgent);

            backgroundWorker1.ReportProgress(1, "[request.UrlReferrer]");
            backgroundWorker1.ReportProgress(1, string.Join("\n", request.UrlReferrer));


            //POST请求处理 找到最簡單的方法
            //https://gist.github.com/pingec/9bf2fd92ac85032b5e30d487a35789a0
            string documentContents;
            string InputStream;
            using (Stream receiveStream = request.InputStream)
            {
                //using (StreamReader readStream = new StreamReader(receiveStream, Encoding.UTF8))
                using (StreamReader readStream = new StreamReader(receiveStream, request.ContentEncoding))
                {
                    documentContents = readStream.ReadToEnd();
                }
            }
            InputStream = documentContents.Replace("&", "\n");
            InputStream = Uri.UnescapeDataString(InputStream); //UrlDecode ...奇怪, SharpDevelop 不能用 HttpUtility.UrlDecode(InputStream);
            backgroundWorker1.ReportProgress(1, "[request.InputStream]");
            backgroundWorker1.ReportProgress(1, InputStream);
            _SaveLog("documentContents=" + InputStream);


            //HttpUtility.UrlDecode(request.Request.QueryString["imgname"]);



            /*
            //POST请求处理
            if (request.HasEntityBody){
                Stream SourceStream = request.InputStream;
                                	
                byte[] currentChunk = ReadLineAsBytes(SourceStream);
                //获取数据中有空白符需要去掉，输出的就是post请求的参数字符串 如：username=linezero
                string temp = Encoding.Default.GetString(currentChunk).Replace(" ", "");
                backgroundWorker1.ReportProgress(1, temp);
            }
            */


            //ASP.NET 的說法
            //Request.Params         是所有post和get傳過来的值的集合,
            //Request.Form            是取post傳值, 
            //Request.QueryString 是get傳過来的值 EX: request.QueryString["linezero"]

            /*
            string[] types = request.AcceptTypes;
            if (types != null)
            {   
              foreach (string s in types)
              {
                  Console.WriteLine(s);
              }
            }
            */




            //-----------------
            //response 回應處理
            //-----------------

            //string s = request.QueryString["command"];
            //do something as you want
            //string responseString = string.Format(" {0}", DateTime.Now);

            string InstanceID = "";
            string param_str = "";
            string _action = "";
            string responseString = "";
            int PageID = 0;


            //處理 jpg 檔回傳 //http://hant.ask.helplib.com/c-Sharp/post_10216046 //if (request.RawUrl.EndsWith(".jpg"))
            if (request.RawUrl.ToLower().Contains(".jpg"))
            {
                string jpg_fn = request.RawUrl.Replace("/", "");  //request.RawUrl.Substring(2, request.RawUrl.Length-2) ; //MyPath+_CutLeft(ARequestInfo.Document, 1);
                _SaveLog("jpg_fn=" + jpg_fn);
                if (File.Exists(jpg_fn))
                {
                    using (FileStream fs = new FileStream(jpg_fn, FileMode.Open, FileAccess.Read))
                    {
                        byte[] buffer_jpg = new byte[fs.Length];
                        fs.Read(buffer_jpg, 0, (int)fs.Length); //將檔案讀到快取區
                        response.StatusCode = 200;
                        response.Headers.Add("Access-Control-Allow-Origin", "*");
                        response.ContentType = "image/jpg";
                        response.ContentLength64 = buffer_jpg.Length;
                        var output_stream = response.OutputStream; //獲取請求流
                        output_stream.Write(buffer_jpg, 0, buffer_jpg.Length);  //將快取區的位元組數寫入當前請求流返回
                        output_stream.Close();
                    }

                }
                return;
            }





            //首頁
            _action = StrKeyValue(documentContents, "action"); //request.QueryString["action"] 或 request.Url.Query["action"].ToString();
            _SaveLog("_action=" + _action);
            if (_action == "")
            {
                responseString = GetHtml_Login(param_str);
            }


            //登入            
            if (_action == "login")
            {
                string usr = StrKeyValue(documentContents, "usr").Trim();
                string pwd = StrKeyValue(documentContents, "pwd").Trim();

                if (Chk_Login(usr, pwd))
                {
                    //登入成功進入菜單
                    InstanceID = FormatDateTime("yyyymmddhhnnsszzz", DateTime.Now); //自製 cookie
                    param_str = "InstanceID=" + InstanceID + "&PageID=1";
                    MakeUserMenuDataSet(InstanceID); //建立使用者菜單
                    responseString = GetHtml_Menu(param_str);
                }
                else
                {
                    //登入失敗進入錯誤處理
                    responseString = GetHtml_LoginErr(param_str);
                }

            }


            //菜單中做動作            
            if (_action == "menu")
            {
                InstanceID = StrKeyValue(documentContents, "InstanceID");
                PageID = _StrToInt(StrKeyValue(documentContents, "PageID"));
                if (StrKeyValue(documentContents, "B1").ToString() != "")
                { //進入上頁
                    UpdateUserMenuDataSet(InstanceID, documentContents); //更新使用者菜單(數量)
                    PageID = PageID - 1;
                    if (PageID < 1)
                    {
                        PageID = 1;
                    }
                    param_str = "InstanceID=" + InstanceID + "&PageID=" + PageID.ToString();
                    responseString = GetHtml_Menu(param_str);
                }
                if (StrKeyValue(documentContents, "B2").ToString() != "")
                { //進入下頁
                    UpdateUserMenuDataSet(InstanceID, documentContents); //更新使用者菜單(數量)
                    PageID = PageID + 1;
                    if (PageID > 1)
                    {
                        PageID = 1;
                    }
                    param_str = "InstanceID=" + InstanceID + "&PageID=" + PageID.ToString();
                    responseString = GetHtml_Menu(param_str);
                }
                if (StrKeyValue(documentContents, "B3").ToString() != "")
                { //進入取消
                    ResetUserMenuDataSet(InstanceID); //重置使用者菜單(數量)
                    param_str = "InstanceID=" + InstanceID + "&PageID=1";
                    responseString = GetHtml_Menu(param_str);
                }
                if (StrKeyValue(documentContents, "B4").ToString() != "")
                { //進入清單
                    UpdateUserMenuDataSet(InstanceID, documentContents); //更新使用者菜單(數量) 
                    param_str = "InstanceID=" + InstanceID;
                    responseString = GetHtml_SubTotal(param_str);
                }
            }


            //清單中做動作
            if (_action == "subtotal")
            {
                InstanceID = StrKeyValue(documentContents, "InstanceID");
                if (StrKeyValue(documentContents, "B1").ToString() != "")
                { //小計
                    UpdateUserMenuDataSet(InstanceID, documentContents); //更新使用者菜單(數量)	
                    param_str = "InstanceID=" + InstanceID;
                    responseString = GetHtml_SubTotal(param_str);
                }
                if (StrKeyValue(documentContents, "B2").ToString() != "")
                { //繼續點餐
                    UpdateUserMenuDataSet(InstanceID, documentContents); //更新使用者菜單(數量)
                    param_str = "InstanceID=" + InstanceID + "&PageID=1";
                    responseString = GetHtml_Menu(param_str);
                }
                if (StrKeyValue(documentContents, "B3").ToString() != "")
                { //交易取消
                    ResetUserMenuDataSet(InstanceID); //重置使用者菜單(數量)
                    param_str = "InstanceID=" + InstanceID + "&PageID=1";
                    responseString = GetHtml_Menu(param_str);
                }
                if (StrKeyValue(documentContents, "B4").ToString() != "")
                { //交易完成
                    ResetUserMenuDataSet(InstanceID); //重置使用者菜單(數量)
                    param_str = "InstanceID=" + InstanceID + "&PageID=1";
                    responseString = GetHtml_Menu(param_str);
                }
            }




            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(responseString);
            //response.ContentLength64 = buffer.Length;

            System.IO.Stream output = response.OutputStream;
            output.Write(buffer, 0, buffer.Length);

            //關閉輸出流，釋放相應資源。
            output.Close();

            _SaveLog("Call ProcessHttpClient() End");

        }


        string StrKeyValue(string sour, string keystr)
        {
            string rv = "";
            string upcase_sour = sour.ToUpper();
            string upcase_keystr = keystr.ToUpper() + "=";
            int idx_start = -1;


            if (upcase_sour.Length > upcase_keystr.Length)
            {
                for (int i = 0; i <= (upcase_sour.Length - upcase_keystr.Length); i++)
                {

                    //MessageBox.Show("i="+i.ToString()+"; Length="+upcase_keystr.Length.ToString());

                    if (upcase_sour.Substring(i, upcase_keystr.Length) == upcase_keystr)
                    {
                        idx_start = i + upcase_keystr.Length;
                        break;
                    }
                }
                //MessageBox.Show("idx_start="+idx_start.ToString());

                if (idx_start != -1)
                {
                    for (int i = idx_start; i <= (sour.Length - 1); i++)
                    {
                        if (sour.Substring(i, 1) == "&")
                        {
                            break;
                        }
                        rv = rv + sour.Substring(i, 1);
                    }
                }
            }

            return rv;
        }


        bool Chk_Login(string _usr, string _pwd)
        {
            bool rv = false;
            if (_usr == "123" && _pwd == "456")
            {
                rv = true;
            }

            return rv;
        }


        byte[] ReadLineAsBytes(Stream SourceStream)
        {
            var resultStream = new MemoryStream();
            while (true)
            {
                int data = SourceStream.ReadByte();
                resultStream.WriteByte((byte)data);
                if (data <= 10)
                    break;
            }
            resultStream.Position = 0;
            byte[] dataBytes = new byte[resultStream.Length];
            resultStream.Read(dataBytes, 0, dataBytes.Length);
            return dataBytes;
        }

        void BackgroundWorker1ProgressChanged(object sender, System.ComponentModel.ProgressChangedEventArgs e)
        {
            //e.ProgressPercentage為剛剛傳入的參數
            //this.Text = e.ProgressPercentage.ToString();
            if (e.ProgressPercentage == 0)
            {
                richTextBox1.Clear();
            }
            else
            {
                richTextBox1.AppendText((String)e.UserState + "\n");
            }

        }

        void _SaveLog(string log)
        {
            string log_fn = "Log_" + FormatDateTime("yyyymmdd", DateTime.Now.Date) + ".log";
            string log_time = DateTime.Now.ToString("yy-MM-dd HH:mm:ss", System.Globalization.DateTimeFormatInfo.InvariantInfo);

            /* 多執行緒中會發生檔案互咬(LOCK)
			StreamWriter sw = new StreamWriter(log_fn, true, System.Text.Encoding.Default);
			sw.WriteLine(log_time+" "+log);
			sw.Close();
			*/


            //https://www.died.tw/2012/08/c-using-streamwriter-ioexception.html
            //作者說:在找解法的時候，也試過3rd party 的logging方式，如 NLog、log4net ，但是效能都會被拖到剩下1/3不到，只剩每秒不到200次，後來還是回頭自己寫效率比較好。
            using (var fs = new FileStream(log_fn, FileMode.Append, FileAccess.Write, FileShare.ReadWrite))
            {
                using (var log_handle = new StreamWriter(fs, Encoding.Default))  //不加 Encoding.Default , 中文寫出變亂碼
                {
                    //要在外層先宣告 private static readonly object LockFile = new object();
                    lock (LockFile)
                    {
                        log_handle.WriteLine(log_time + " " + log);
                    }
                }
            }




        }

        string FormatDateTime(string format, DateTime d)
        {
            string f = "";
            string tmp, tmp2;
            for (int i = 0; i <= format.Length - 1; i++)
            {
                tmp = format.Substring(i, 1);
                tmp2 = tmp;
                if (tmp == "Y" || tmp == "y") tmp2 = "y";
                if (tmp == "M" || tmp == "m") tmp2 = "M";
                if (tmp == "D" || tmp == "d") tmp2 = "d";
                if (tmp == "H" || tmp == "h") tmp2 = "H";
                if (tmp == "N" || tmp == "n") tmp2 = "m";
                if (tmp == "S" || tmp == "s") tmp2 = "s";
                if (tmp == "Z" || tmp == "z") tmp2 = "f"; //2008/12/17
                f = f + tmp2;

            }

            //加了 System.Globalization.DateTimeFormatInfo.InvariantInfo 才不會用民國
            return d.ToString(f, System.Globalization.DateTimeFormatInfo.InvariantInfo);
        }


        //根據登入 ID, 建立使用者菜單
        void MakeUserMenuDataSet(string id)
        {
            //MemDataset1.Rows.Add();

            MemDataset1.Rows.Add(id, "01", "浦燒鰻魚", 40, 0, 0);
            MemDataset1.Rows.Add(id, "02", "甜蝦", 40, 0, 0);
            MemDataset1.Rows.Add(id, "03", "章魚", 40, 0, 0);
            MemDataset1.Rows.Add(id, "04", "北寄貝", 40, 0, 0);
            MemDataset1.Rows.Add(id, "05", "烏賊", 40, 0, 0);
            MemDataset1.Rows.Add(id, "06", "鮭魚肚", 40, 0, 0);


        }

        //根據登入 ID, 重置使用者菜單(數量)
        void ResetUserMenuDataSet(string id)
        {
            //https://edwardkuo.imas.tw/paper/2016/01/21/Net/2016/2016-01-21/
            foreach (DataRow od in MemDataset1.Rows)
            {
                if (od["InstanceID"].ToString().Trim() == id.Trim())
                {
                    od["qty"] = 0;
                    od["saleprice"] = 0;
                }
            }

        }

        //根據登入 ID, 更新使用者菜單(數量)
        void UpdateUserMenuDataSet(string id, string param)
        {
            //https://edwardkuo.imas.tw/paper/2016/01/21/Net/2016/2016-01-21/
            string barcode = "";
            foreach (DataRow od in MemDataset1.Rows)
            {
                if (od["InstanceID"].ToString().Trim() == id.Trim())
                {
                    barcode = od["BarcodeID"].ToString().Trim();

                    //菜單中拉選數量
                    if (StrKeyValue(param, "D_" + barcode) != "")
                    {
                        od["qty"] = _StrToInt(StrKeyValue(param, "D_" + barcode));
                        od["saleprice"] = (int)od["unitprice"] * (int)od["qty"];
                    }

                    //清單中勾選刪除
                    if (StrKeyValue(param, "C_" + barcode) == "on")
                    {
                        od["qty"] = 0;
                        od["saleprice"] = 0;
                    }
                }
            }
        }


        int _StrToInt(string str)
        {
            int rv = 0;

            try
            {
                rv = Convert.ToInt32(str);
            }
            catch (Exception)
            {
                ; ;
            }


            return rv;
        }


        string GetHtml_Login(string param_str)
        {
            StringBuilder sb = new StringBuilder();

            sb.Append("<html>");
            sb.Append("<head>");

            sb.Append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
            sb.Append("<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0\" />");


            sb.Append("<title>登入作業</title>");
            sb.Append("</head>");

            sb.Append("<body bgcolor=\"#FFFFFF\">");

            sb.Append("<form method=\"POST\">");
            sb.Append("    <input type=\"hidden\" name=\"action\" value=\"login\">");
            sb.Append("    <p align=\"center\">登入作業</p>");

            sb.Append("    <p align=\"center\"><img src=\"login.jpg\" width=\"90\" height=\"90\"></p>");

            sb.Append("    <p align=\"center\">帳號：<input type=\"text\" size=\"20\"");
            sb.Append("    name=\"usr\"></p>");
            sb.Append("    <p align=\"center\">密碼：<input type=\"password\" size=\"20\"");
            sb.Append("    name=\"pwd\"></p>");
            sb.Append("    <p align=\"center\"><input type=\"reset\" name=\"B1\"");
            sb.Append("    value=\"重設\">　　　<input type=\"submit\" name=\"B2\" value=\"登入\"></p>");
            sb.Append("    <p>　</p>");
            sb.Append("</form>");
            sb.Append("</body>");
            sb.Append("</html>");


            return sb.ToString();
        }

        string GetHtml_Menu(string param_str)
        {

            string InstanceID = StrKeyValue(param_str, "InstanceID").Trim(); //登入 InstanceID
            int PageID = _StrToInt(StrKeyValue(param_str, "PageID")); //頁次
            string jpg_fn = "";


            StringBuilder sb = new StringBuilder();

            sb.Append("<html>");
            sb.Append("<head>");

            sb.Append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
            sb.Append("<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0\" />");


            sb.Append("<title>菜單選擇</title>");
            sb.Append("</head>");

            sb.Append("<body bgcolor=\"#FFFFFF\">");

            sb.Append("<form method=\"POST\">");
            sb.Append("    <input type=\"hidden\" name=\"action\" value=\"menu\">");
            sb.Append("    <input type=\"hidden\" name=\"InstanceID\" value=\"" + InstanceID + "\">");
            sb.Append("    <input type=\"hidden\" name=\"PageID\" value=" + PageID.ToString() + ">");

            sb.Append("    <p align=\"center\">分類：<select name=\"DD1\" size=\"1\">");
            sb.Append("        <option selected>壽司</option>");
            sb.Append("        <option>套餐</option>");
            sb.Append("    </select>　　桌號：<select name=\"DD2\" size=\"1\">");
            sb.Append("        <option>1</option>");
            sb.Append("        <option>2</option>");
            sb.Append("        <option>3</option>");
            sb.Append("        <option>4</option>");
            sb.Append("        <option>5</option>");
            sb.Append("    </select>　　序：</p>");


            sb.Append("    <div align=\"center\"><center><table border=\"0\">");
            sb.Append("    <tr>");
            sb.Append("        <td>商品</td>");
            sb.Append("        <td>ID</td>");
            sb.Append("        <td>名稱</td>");
            sb.Append("        <td>單價</td>");
            sb.Append("        <td>數量</td>");
            sb.Append("    </tr>");


            //建立菜單
            foreach (DataRow od in MemDataset1.Rows)
            {
                if (od["InstanceID"].ToString().Trim() == InstanceID.Trim())
                {

                    sb.Append("        <tr>");
                    jpg_fn = od["BarcodeID"] + ".jpg";
                    if (File.Exists(jpg_fn))
                    {
                        sb.Append("            <td><img src=\"" + jpg_fn + "\" width=\"90\" height=\"55\"></td>");
                    }
                    else
                    {
                        sb.Append("            <td>　</td>");
                    }

                    sb.Append("            <td>" + od["BarcodeID"] + "</td>");
                    sb.Append("            <td>" + od["PluName"] + "</td>");
                    sb.Append("            <td>" + od["unitPrice"] + "</td>");
                    sb.Append("            <td><select name=\"D_" + od["BarcodeID"] + "\" size=\"1\">");
                    sb.Append(GetSubHtml_ComboxItem(0, 10, (int)od["qty"]));
                    sb.Append("            </select></td>");
                    sb.Append("        </tr>");

                }
            }



            sb.Append("    </table>");
            sb.Append("    </center></div>");
            sb.Append("    <p align=\"center\">");
            sb.Append("    <input type=\"submit\" name=\"B1\" value=\"菜單上頁\" action2=\"pgup\">");
            sb.Append("    <input type=\"submit\" name=\"B2\" value=\"菜單下頁\" action2=\"pgdn\">");

            sb.Append("    <p align=\"center\">");
            sb.Append("    <input type=\"submit\" name=\"B3\" value=\"交易取消\" action2=\"cancel\">");
            sb.Append("    <input type=\"submit\" name=\"B4\" value=\"清單小計\" action2=\"total_list\">");
            sb.Append("    <p align=\"center\">　</p>");
            sb.Append("    <p align=\"center\">　</p>");


            sb.Append("</form>");
            sb.Append("</body>");
            sb.Append("</html>");


            return sb.ToString();
        }




        string GetHtml_LoginErr(string param_str)
        {
            StringBuilder sb = new StringBuilder();

            sb.Append("<html>");
            sb.Append("<head>");

            sb.Append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
            sb.Append("<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0\" />");


            sb.Append("<title>登入失敗</title>");
            sb.Append("</head>");

            sb.Append("<body bgcolor=\"#FFFFFF\">");

            sb.Append("<form method=\"POST\">");
            sb.Append("    <p>　</p>");
            sb.Append("    <p align=\"center\"><font color=\"#FF0000\">登入錯誤, 帳密失敗 !!</font></p>");
            sb.Append("    <p align=\"center\">　</p>");
            sb.Append("    <p align=\"center\"><input type=\"submit\" name=\"B1\"");
            sb.Append("    value=\"重新登入\"></p>");
            sb.Append("    <p>　</p>");
            sb.Append("</form>");
            sb.Append("</body>");
            sb.Append("</html>");


            return sb.ToString();
        }


        string GetHtml_SubTotal(string param_str)
        {

            string InstanceID = StrKeyValue(param_str, "InstanceID").Trim(); //登入 InstanceID
            string jpg_fn = "";


            StringBuilder sb = new StringBuilder();

            sb.Append("<html>");
            sb.Append("<head>");

            sb.Append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
            sb.Append("<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0\" />");


            sb.Append("<title>清單小計</title>");


            sb.Append("<script type=\"text/javascript\">");
            sb.Append("  function _QueryBox(msg)");
            sb.Append("  {");
            sb.Append("    return confirm(msg);");
            sb.Append("  }");
            sb.Append("</script>");



            sb.Append("</head>");

            sb.Append("<body bgcolor=\"#FFFFFF\">");

            sb.Append("<form method=\"POST\">");

            sb.Append("    <input type=\"hidden\" name=\"action\" value=\"subtotal\">");
            sb.Append("    <input type=\"hidden\" name=\"InstanceID\" value=\"" + InstanceID + "\">");

            sb.Append("    <p align=\"center\">分類：<select name=\"DD1\" size=\"1\">");
            sb.Append("        <option selected>壽司</option>");
            sb.Append("        <option>套餐</option>");
            sb.Append("    </select>　　桌號：<select name=\"DD2\" size=\"1\">");
            sb.Append("        <option>1</option>");
            sb.Append("        <option>2</option>");
            sb.Append("        <option>3</option>");
            sb.Append("        <option>4</option>");
            sb.Append("        <option>5</option>");
            sb.Append("    </select>　　序：</p>");


            sb.Append("    <div align=\"center\"><center><table border=\"0\">");
            sb.Append("    <tr>");
            sb.Append("        <td>刪除</td>");
            sb.Append("        <td>商品</td>");
            sb.Append("        <td>名稱</td>");
            sb.Append("        <td>數量</td>");
            sb.Append("        <td>金額</td>");
            sb.Append("        <td>特殊需求</td>");
            sb.Append("    </tr>");




            //建立清單
            int tot_amt = 0;
            foreach (DataRow od in MemDataset1.Rows)
            {
                if (od["InstanceID"].ToString().Trim() == InstanceID.Trim())
                {
                    if ((int)od["qty"] != 0)
                    {
                        sb.Append("        <tr>");
                        sb.Append("            <td><input type=\"checkbox\" name=\"C_" + od["BarcodeID"] + "\"></td>");
                        sb.Append("            <td>" + od["BarcodeID"] + "</td>");
                        sb.Append("            <td>" + od["PluName"] + "</td>");
                        sb.Append("            <td>" + od["qty"] + "</td>");
                        sb.Append("            <td>" + od["salePrice"] + "</td>");
                        sb.Append("            <td>  </td>");
                        sb.Append("        </tr>");
                    }

                    tot_amt = tot_amt + (int)od["salePrice"];

                }
            }




            sb.Append("    </table>");
            sb.Append("    </center></div><p align=\"center\">");
            sb.Append("    <input type=\"submit\" name=\"B1\" value=\"小計：" + tot_amt.ToString() + "\"");
            sb.Append("    <p align=\"center\">　</p>");
            sb.Append("    <p align=\"center\">　</p>");
            sb.Append("    <p align=\"center\">");
            sb.Append("    <input type=\"submit\" name=\"B2\" value=\"繼續點餐\">　");
            sb.Append("    <input type=\"submit\" name=\"B3\" value=\"交易取消\" onclick=\"return _QueryBox('是否確認[交易取消]')\">　");
            sb.Append("    <input type=\"submit\" name=\"B4\" value=\"結帳完成\" onclick=\"return _QueryBox('是否確認[結帳完成]')\">");
            sb.Append("    </p>");
            sb.Append("    <p align=\"center\">　</p>");
            sb.Append("    <p align=\"center\">　</p>");


            sb.Append("</form>");
            sb.Append("</body>");
            sb.Append("</html>");


            return sb.ToString();
        }


        string GetSubHtml_ComboxItem(int _from, int _to, int select_id)
        {
            StringBuilder sb = new StringBuilder();

            for (int i = _from; i <= _to; i++)
            {
                if (i == select_id)
                {
                    sb.Append("                <option selected>" + i.ToString() + "</option>");
                }
                else
                {
                    sb.Append("                <option>" + i.ToString() + "</option>");
                }
            }


            return sb.ToString();
        }

        void TextBox1DoubleClick(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(textBox1.Text);
        }






    }


}

