﻿unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ubarcodes,
  UniqueInstance, IdHTTPServer, IdIPWatch, IniFiles, memds, LazUTF8,
  IdCustomHTTPServer, IdContext, IdURI, IdGlobal, lclintf, Menus, IdHeaderList,
  windows, IdStack; //idsync;


//Project Options 路徑之 Othet unit files 加入路徑
//"C:\lazarus\_VCL\INDY_10_6_2\Lib\lib\i386-win32\"
//"C:\lazarus\components\lazutils\lib\i386-win32\"

type

  { TForm1 }

  TForm1 = class(TForm)
    BarcodeQR1: TBarcodeQR;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    IdHTTPServer1: TIdHTTPServer;
    IdIPWatch1: TIdIPWatch;
    Label1: TLabel;
    Label2: TLabel;
    MemDataset1: TMemDataset;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    PopupMenu1: TPopupMenu;
    UniqueInstance1: TUniqueInstance;
    procedure ComboBox1Change(Sender: TObject);
    procedure Edit1DblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure IdHTTPServer1CommandGet(AContext: TIdContext;
      ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
    procedure IdHTTPServer1CommandOther(AContext: TIdContext;
      ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
    procedure IdHTTPServer1CreatePostStream(AContext: TIdContext;
      AHeaders: TIdHeaderList; var VPostStream: TStream);
    procedure MenuItem1Click(Sender: TObject);
  private
    procedure _SaveLog(log: string);
    function  _StrToInt(Str:String): integer;
    function  _Right(Str:String ; n:integer): String;
    function  _Left(str: String; len: integer):String;
    function  _CutLeft(str: String; len: integer): String;
    procedure DecodeParams(const AValue: String; Params: TStrings);
    procedure MyDecodeAndSetParams(ARequestInfo: TIdHTTPRequestInfo);
    procedure MakeUserMenuDataSet(id: String);
    procedure ResetUserMenuDataSet(id: String);
    procedure UpdateUserMenuDataSet(id: String; param: String);
    function GetHtml_Login(param: TStringList): String;
    function GetHtml_LoginErr(param: TStringList): String;
    function GetHtml_Menu(param: TStringList): String;
    function GetHtml_SubTotal(param: TStringList): String;
    function GetSubHtml_ComboxItem(_from: integer; _to: integer; select_id: integer): String;
    function Chk_Login(_usr: String; _pwd:String): boolean;
    procedure MemoClear;  //2019/07/29
    procedure MemoAppend; //2019/07/29
  public

  end;




var
  Form1: TForm1;
  MyIni:TIniFile;
  MyPath:String;
  MyList:TStringList;
  run_once: boolean;
  can_close: boolean;
  pg_ver: String; //程式版本
  log_fn: String;
  wifi_ip: String;
  MyCriticalSection: TRTLCriticalSection; //2019/07/26 uses windows
  //MyCriticalSection: TCriticalSection;  //2019/07/26 uses lcltype

  memo_log: String;

implementation

{$R *.lfm}

{ TForm1 }

//uses IdStack
function GetAllIP: String;
begin
  TIdStack.IncUsage;
  try
    Result := GStack.LocalAddresses.Text;
  finally
    TIdStack.DecUsage;
  end;
end;

//據說這樣寫比較好
//Note - the TIdStack.LocalAddesses property is not thread-safe. If you have
//threads involved, a safer approach would be to use the
//TIdStack.AddLocalAddressesToList() method instead, ie:
function GetAllIP2: String;
var
  List: TStringList;
begin

  List := TStringList.Create;
  try
    TIdStack.IncUsage;
    try
      GStack.AddLocalAddressesToList(List);
    finally
      TIdStack.DecUsage;
    end;
    Result := List.Text;
  finally
    List.Free;
  end;
end;




procedure TForm1.FormCreate(Sender: TObject);
begin
  MyIni := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
  MyPath := ExtractFilePath(Application.ExeName);

  pg_ver:='V19.0716'; //版本

  MyList := TStringList.Create;
  MyList.Clear;

  run_once:=false;

  can_close:=false;

  InitializeCriticalSection(MyCriticalSection); //2019/07/26
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  if (run_once) then exit;

  run_once:=true;

  //寫版本記錄之動作放在 FormActivate() 才不會因程式重覆執行時重覆寫版本記錄
  _SaveLog('●程式啟動=>'+Application.ExeName+' (版本:'+pg_ver+')');
  Form1.Caption:=Form1.Caption+' (版本:'+pg_ver+')';

  IdIPWatch1.Active := true;
  IdIPWatch1.ForceCheck;

  wifi_ip:=MyIni.ReadString('PARAMETER', 'WIFI_IP', '');

  ComboBox1.ItemIndex:=MyIni.ReadInteger('PARAMETER', 'ComboBox1_ItemIndex', 0);
  if (Trim(wifi_ip)<>'') then begin
      Edit1.Text:='http://'+wifi_ip+':'+ComboBox1.Text;
  end else begin
      //Edit1.Text:='http://'+IdIPWatch1.LocalIP+':'+ComboBox1.Text;
      //Edit1.Text:='http://'+IdIPWatch1.CurrentIP+':'+ComboBox1.Text;

      //2019/07/29 -> wifi ip 通常在最後一個
      MyList.Text:=GetAllIP;
      Edit1.Text:='http://'+MyList.Strings[MyList.Count-1]+':'+ComboBox1.Text;
      MyList.Clear;
      //2019/07/29 <-

  end;

  BarcodeQR1.Text:=Edit1.Text; //+':'+ComboBox1.Text;

  //ShowMessage(IdIPWatch1.LocalIP);

  try
    IdHTTPServer1.Active := False;
    IdHTTPServer1.Bindings.Clear;
    IdHTTPServer1.DefaultPort:= StrToIntDef(ComboBox1.Text, 80) ;//StrToInt(ComboBox1.Text);
    //IdHTTPServer1.Bindings.Add.IP := '127.0.0.1'; //IdIPWatch1.LocalIP;
    IdHTTPServer1.Bindings.Add; //也可以不用寫 ip
    IdHTTPServer1.Active := True;
  except
    on E: Exception do begin
        ShowMessage('[IdHTTPServer 啟動失敗]:'+E.Message);
      end;
  end;

  IdIPWatch1.Active := false;



end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin

  IdIPWatch1.Active := true;
  IdIPWatch1.ForceCheck; 

  if (Trim(wifi_ip)<>'') then begin
      Edit1.Text:='http://'+wifi_ip+':'+ComboBox1.Text;
  end else begin
      //Edit1.Text:='http://'+IdIPWatch1.LocalIP+':'+ComboBox1.Text;
      Edit1.Text:='http://'+IdIPWatch1.CurrentIP +':'+ComboBox1.Text;
  end;

  IdIPWatch1.Active := false;
  

  BarcodeQR1.Text:=Edit1.Text; //+':'+ComboBox1.Text;

  try
    IdHTTPServer1.Active := False;
    IdHTTPServer1.Bindings.Clear;
    IdHTTPServer1.DefaultPort:= StrToIntDef(ComboBox1.Text, 80) ;//StrToInt(ComboBox1.Text);
    //IdHTTPServer1.Bindings.Add.IP := '127.0.0.1'; //IdIPWatch1.LocalIP;
    IdHTTPServer1.Bindings.Add; //也可以不用寫 ip
    IdHTTPServer1.Active := True;
  except
      on E: Exception do begin
          ShowMessage('[IdHTTPServer 啟動失敗]:'+E.Message);
        end;
  end;

end;

procedure TForm1.Edit1DblClick(Sender: TObject);
begin
  OpenDocument(Edit1.Text); //uses lclintf
end;



function URLEncode(const s : string) : string;
var uri: TIdURI; //uses IdURI
begin
  uri:=TIdURI.Create();
  Result:=uri.URLEncode(s, IndyTextEncoding_UTF8, IndyTextEncoding_UTF8); //uses IdGlobal
  uri.Free;

  //TIdURI.URLDecode('%C3%84%C3%96%C3%9C', IndyTextEncoding_UTF8)
end;

function URLDecode(const s : string) : string;
var uri: TIdURI; //uses IdURI
begin
  uri:=TIdURI.Create();
  Result:=uri.URLDecode(s, IndyTextEncoding_UTF8, IndyTextEncoding_UTF8); //uses IdGlobal
  uri.Free;

  //TIdURI.URLDecode('%C3%84%C3%96%C3%9C', IndyTextEncoding_UTF8)
end;



procedure TForm1.MemoClear;
begin
  Form1.Memo1.Lines.Clear;
end;

procedure TForm1.MemoAppend;
begin
  Form1.Memo1.Lines.Add(memo_log);
end;

procedure TForm1.IdHTTPServer1CommandGet(AContext: TIdContext;
  ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
var _action: String;
    usr: String;
    pwd: String;
    InstanceID: String;
    PageID: integer;
    jpg_fn: String;
    Stream : TfileStream;
    Strm: TMemoryStream;
    TheString : String;
    aJpg: TJPEGImage;
    TmpList:TStringList;
    //MySync: TIdSync;  //uses idsync
begin
  {
  //OnCommand...事件在工作線程的上下文中被觸發。您必須安全地訪問UI控件與主UI線程同步
  //lazarus 不能用
  TThread.Synchronize(nil,
     procedure
     begin
     Memo1.Text := ARequestInfo.Params.Text;
     end
    );
  }

  //AContext.Connection.IOHandler.DefStringEncoding := IndyUTF8Encoding; //TIdTextEncoding.ANSI;
  //aContext.Connection.IOHandler.DefStringEncoding := IndyTextEncoding_UTF8;

  //ARequestInfo.ContentType := 'text/html;Charset=UTF-8'; //無效

  //MyDecodeAndSetParams(ARequestInfo); //無效

  //AContext.Connection.IOHandler.DefStringEncoding := IndyTextEncoding_UTF8; //無效

  //MySync:=TIdSync.Create();
  //MySync.SynchronizeMethod(@MemoClear); //uses idsync




  {  //remark on 2019/07/30

  Memo1.Lines.Clear;
  Memo1.Lines.Add('[ARequestInfo.RawHeaders.Text]');
  Memo1.Lines.Add(ARequestInfo.RawHeaders.Text);

  Memo1.Lines.Add('[ARequestInfo.Document]');
  Memo1.Lines.Add(ARequestInfo.Document); //從 Google Chrome 抓不出 '/index.htm'

  Memo1.Lines.Add('[ARequestInfo.FormParams]');
  Memo1.Lines.Add(URLDecode(ARequestInfo.FormParams)); //2019/07/29 加上 URLDecode()
  _SaveLog('[ARequestInfo.FormParams]='+URLDecode(ARequestInfo.FormParams));

  Memo1.Lines.Add('[ARequestInfo.UnparsedParams]');
  Memo1.Lines.Add(URLDecode(ARequestInfo.UnparsedParams)); //2019/07/29 加上 URLDecode()
  _SaveLog('[ARequestInfo.UnparsedParams]='+URLDecode(ARequestInfo.UnparsedParams));


  //中文亂碼解決方案, 測試無效
  //DecodeParams(ARequestInfo.QueryParams, ARequestInfo.Params);

  Memo1.Lines.Add('[ARequestInfo.Params.Text]');
  Memo1.Lines.Add(ARequestInfo.Params.Text);  //中文亂碼 參考 https://www.oipapio.com/question-425156
  //Memo1.Lines.Add(TIdTextEncoding.UTF8.GetString(ToBytes(ARequestInfo.Params.Text, Indy8BitEncoding)));
  //Memo1.Lines.Add(tiduri.URLDecode(ARequestInfo.Params.Text)); //無效 https://www.itread01.com/content/1548507271.html
  //Memo1.Lines.Add(IndyTextEncoding_UTF8.GetString(ToBytes(ARequestInfo.Params.Text, IndyTextEncoding_8bit)));
  //Memo1.Lines.Add(URLDecode(ARequestInfo.Params.Text)); //2019/07/29

  //_SaveLog(wincptoutf8(TIdTextEncoding.UTF8.GetString(ToBytes(ARequestInfo.Params.Text, Indy8BitEncoding))));
  _SaveLog(wincptoutf8(ARequestInfo.Params.Text));

  //ARequestInfo.Params.Text 中文亂碼無解, 可改由 URLDecode(ARequestInfo.FormParams) & URLDecode(ARequestInfo.UnparsedParams) 取出



  Memo1.Lines.Add('[ARequestInfo.QueryParams]');
  Memo1.Lines.Add(ARequestInfo.QueryParams);
  //Memo1.Lines.Add(ARequestInfo.Params.Values['Par1'] );
  //Memo1.Lines.Add(ARequestInfo.Params.Values['Par2'] );

  Memo1.Lines.Add('[ARequestInfo.Command]');
  Memo1.Lines.Add(ARequestInfo.Command);  //GET OR POST

  Memo1.Lines.Add('[ARequestInfo.URI]');
  Memo1.Lines.Add(ARequestInfo.URI);
  }


  //2019/07/30 改為 thread-safe 方式
  TThread.Synchronize(nil, @MemoClear);

  memo_log:='[ARequestInfo.RawHeaders.Text]'; TThread.Synchronize(nil, @MemoAppend);
  memo_log:=ARequestInfo.RawHeaders.Text; TThread.Synchronize(nil, @MemoAppend);

  memo_log:='[ARequestInfo.Document]'; TThread.Synchronize(nil, @MemoAppend);
  memo_log:=ARequestInfo.Document; TThread.Synchronize(nil, @MemoAppend); //從 Google Chrome 抓不出 '/index.htm'

  memo_log:='[ARequestInfo.FormParams]'; TThread.Synchronize(nil, @MemoAppend);
  memo_log:=URLDecode(ARequestInfo.FormParams); TThread.Synchronize(nil, @MemoAppend); //2019/07/29 加上 URLDecode()
  _SaveLog('[ARequestInfo.FormParams]='+URLDecode(ARequestInfo.FormParams));

  memo_log:='[ARequestInfo.UnparsedParams]'; TThread.Synchronize(nil, @MemoAppend);
  memo_log:=URLDecode(ARequestInfo.UnparsedParams); TThread.Synchronize(nil, @MemoAppend); //2019/07/29 加上 URLDecode()
  _SaveLog('[ARequestInfo.UnparsedParams]='+URLDecode(ARequestInfo.UnparsedParams));

  //ARequestInfo.Params.Text 中文亂碼無解, 可改由 URLDecode(ARequestInfo.FormParams) & URLDecode(ARequestInfo.UnparsedParams) 取出
  memo_log:='[ARequestInfo.Params.Text]'; TThread.Synchronize(nil, @MemoAppend);
  memo_log:=ARequestInfo.Params.Text; TThread.Synchronize(nil, @MemoAppend);
  _SaveLog(wincptoutf8(ARequestInfo.Params.Text));

  memo_log:='[ARequestInfo.QueryParams]'; TThread.Synchronize(nil, @MemoAppend);
  memo_log:=ARequestInfo.QueryParams; TThread.Synchronize(nil, @MemoAppend);

  memo_log:='[ARequestInfo.Command]'; TThread.Synchronize(nil, @MemoAppend);
  memo_log:=ARequestInfo.Command; TThread.Synchronize(nil, @MemoAppend);  //GET OR POST

  memo_log:='[ARequestInfo.URI]'; TThread.Synchronize(nil, @MemoAppend);
  memo_log:=ARequestInfo.URI; TThread.Synchronize(nil, @MemoAppend);



  //-----------------
  //response 回應處理
  //-----------------


  //2019/07/22 -> //處理 jpg 檔回傳
  if (_Right(UpperCase(ARequestInfo.Document), 4) = '.JPG') then begin   //通常 ARequestInfo.Document 跟 ARequestInfo.URI 內容相同
      jpg_fn:=MyPath+_CutLeft(ARequestInfo.Document, 1);
      _SaveLog('jpg_fn='+jpg_fn);
      if FileExists(jpg_fn) then begin

          {
          //部分菜單照片不會秀
          Stream := TfileStream.Create(jpg_fn, fmOpenRead or fmShareDenyWrite );
          Stream.Position := 0;
          AResponseInfo.ResponseNo := 200;
          AResponseInfo.ContentType := 'image/jpeg';  //GetMimeTypeFromFile(jpg_fn);

          //AResponseInfo.ContentStream := Stream;
          //AResponseInfo.ContentLength := -1; // let TIdHTTPServer calculate it for


          //AContext.Connection.IOHandler.Write(Stream, Stream.Size);
          }

          {
          //也是部分菜單照片不會秀
          AResponseInfo.ResponseNo := 200;
          AResponseInfo.ContentType := 'image/jpeg';
          AResponseInfo.ServeFile(AContext, jpg_fn);
          }

          //2019/07/25  //也是部分菜單照片不會秀
          AResponseInfo.ContentType:='image/jpeg';
          AResponseInfo.ContentStream := TFileStream.Create(jpg_fn, fmOpenRead);




          //setlength(TheString, stream.size);
          //Stream.Read(TheString[1], stream.size);

          //AResponseInfo.WriteHeader;
          //AResponseInfo.WriteContent;






          {
          if ARequestInfo.PostStream <> nil then
          begin
             ARequestInfo.PostStream.Position := 0;
             Stream := TFileStream.Create(jpg_fn, fmCreate);
             Stream.CopyFrom(ARequestInfo.PostStream, ARequestInfo.PostStream.Size); { Copy 流 }
             Stream.Free;
          end;
          }

          {
          Strm := TMemoryStream.Create;
          try
            //TGetImageStream.GetImage(Strm);
            Strm.Position := 0;
          except
            Strm.Free;
            raise;
          end;
          AResponseInfo.ResponseNo := 200;
          AResponseInfo.ContentType := 'image/jpeg';
          AResponseInfo.ContentStream := Strm;
          }

          exit;
      end;
  end;
  //2019/07/22 <-




  //首頁
  _action:=Trim(ARequestInfo.Params.Values['action']);
  _SaveLog('_action='+_action); //2019/07/22
  if (_action='') then begin
      AResponseInfo.ContentText := GetHtml_Login(MyList); //'<html>中文</html>';
      AResponseInfo.ContentType := 'text/html';
      AResponseInfo.CharSet := 'utf-8';
      AContext.Connection.IOHandler.DefAnsiEncoding := IndyUTF8Encoding;
  end;

  //登入
  if (_action='login') then begin
      usr:=Trim(ARequestInfo.Params.Values['usr']);
      pwd:=Trim(ARequestInfo.Params.Values['pwd']);

      if (Chk_Login(usr, pwd)=true) then begin
          //登入成功進入菜單
          InstanceID:=FormatDateTime('yyyymmddhhnnsszzz', Now); //自製 cookie
          MakeUserMenuDataSet(InstanceID); //建立使用者菜單
          MyList.Clear;
          MyList.Add('InstanceID='+InstanceID);
          MyList.Add('PageID=1');
          AResponseInfo.ContentText := GetHtml_Menu(MyList);
          AResponseInfo.ContentType := 'text/html';
          AResponseInfo.CharSet := 'utf-8';
          AContext.Connection.IOHandler.DefAnsiEncoding := IndyUTF8Encoding;
      end else begin
          //登入失敗進入錯誤處理
          AResponseInfo.ContentText := GetHtml_LoginErr(MyList);
          AResponseInfo.ContentType := 'text/html';
          AResponseInfo.CharSet := 'utf-8';
          AContext.Connection.IOHandler.DefAnsiEncoding := IndyUTF8Encoding;
      end;


  end;

  //菜單中做動作
  if (_action='menu') then begin
      InstanceID:=ARequestInfo.Params.Values['InstanceID'];
      PageID:=_StrToInt(ARequestInfo.Params.Values['PageID']);
      if (Trim(ARequestInfo.Params.Values['B1'])<>'') then begin //進入上頁
          UpdateUserMenuDataSet(InstanceID, ARequestInfo.Params.Text); //更新使用者菜單(數量)
          PageID:=PageID-1;
          if PageID<1 then PageID:=1;
          MyList.Clear;
          MyList.Add('InstanceID='+InstanceID);
          MyList.Add('PageID='+IntToStr(PageID));
          AResponseInfo.ContentText := GetHtml_Menu(MyList);
          AResponseInfo.ContentType := 'text/html';
          //AResponseInfo.ContentType := 'image/jpeg'; //2019/07/22
          AResponseInfo.CharSet := 'utf-8';
          AContext.Connection.IOHandler.DefAnsiEncoding := IndyUTF8Encoding;
      end;
      if (Trim(ARequestInfo.Params.Values['B2'])<>'') then begin //進入下頁
          UpdateUserMenuDataSet(InstanceID, ARequestInfo.Params.Text); //更新使用者菜單(數量)
          PageID:=PageID+1;
          if PageID>1 then PageID:=1;
          MyList.Clear;
          MyList.Add('InstanceID='+InstanceID);
          MyList.Add('PageID='+IntToStr(PageID));
          AResponseInfo.ContentText := GetHtml_Menu(MyList);
          AResponseInfo.ContentType := 'text/html';
          AResponseInfo.CharSet := 'utf-8';
          AContext.Connection.IOHandler.DefAnsiEncoding := IndyUTF8Encoding;
      end;
      if (Trim(ARequestInfo.Params.Values['B3'])<>'') then begin //進入取消
          ResetUserMenuDataSet(InstanceID); //重置使用者菜單(數量)
          MyList.Clear;
          MyList.Add('InstanceID='+InstanceID);
          MyList.Add('PageID=1');
          AResponseInfo.ContentText := GetHtml_Menu(MyList);
          AResponseInfo.ContentType := 'text/html';
          AResponseInfo.CharSet := 'utf-8';
          AContext.Connection.IOHandler.DefAnsiEncoding := IndyUTF8Encoding;
      end;
      if (Trim(ARequestInfo.Params.Values['B4'])<>'') then begin //進入清單
          UpdateUserMenuDataSet(InstanceID, ARequestInfo.Params.Text); //更新使用者菜單(數量)
          MyList.Clear;
          MyList.Add('InstanceID='+InstanceID);
          AResponseInfo.ContentText := GetHtml_SubTotal(MyList);
          AResponseInfo.ContentType := 'text/html';
          AResponseInfo.CharSet := 'utf-8';
          AContext.Connection.IOHandler.DefAnsiEncoding := IndyUTF8Encoding;
      end;
  end;

  //清單中做動作
  if (_action='subtotal') then begin
      InstanceID:=ARequestInfo.Params.Values['InstanceID'];
      if (Trim(ARequestInfo.Params.Values['B1'])<>'') then begin //小計
          UpdateUserMenuDataSet(InstanceID, ARequestInfo.Params.Text); //更新使用者菜單(數量)
          MyList.Clear;
          MyList.Add('InstanceID='+InstanceID);
          AResponseInfo.ContentText := GetHtml_SubTotal(MyList);
          AResponseInfo.ContentType := 'text/html';
          AResponseInfo.CharSet := 'utf-8';
          AContext.Connection.IOHandler.DefAnsiEncoding := IndyUTF8Encoding;
      end;
      if (Trim(ARequestInfo.Params.Values['B2'])<>'') then begin //繼續點餐
          UpdateUserMenuDataSet(InstanceID, ARequestInfo.Params.Text); //更新使用者菜單(數量)
          PageID:=1;
          MyList.Clear;
          MyList.Add('InstanceID='+InstanceID);
          MyList.Add('PageID='+IntToStr(PageID));
          AResponseInfo.ContentText := GetHtml_Menu(MyList);
          AResponseInfo.ContentType := 'text/html';
          AResponseInfo.CharSet := 'utf-8';
          AContext.Connection.IOHandler.DefAnsiEncoding := IndyUTF8Encoding;
      end;
      if (Trim(ARequestInfo.Params.Values['B3'])<>'') then begin //交易取消
          ResetUserMenuDataSet(InstanceID); //重置使用者菜單(數量)
          MyList.Clear;
          MyList.Add('InstanceID='+InstanceID);
          MyList.Add('PageID=1');
          AResponseInfo.ContentText := GetHtml_Menu(MyList);
          AResponseInfo.ContentType := 'text/html';
          AResponseInfo.CharSet := 'utf-8';
          AContext.Connection.IOHandler.DefAnsiEncoding := IndyUTF8Encoding;
      end;
      if (Trim(ARequestInfo.Params.Values['B4'])<>'') then begin //交易完成
          ResetUserMenuDataSet(InstanceID); //重置使用者菜單(數量)
          MyList.Clear;
          MyList.Add('InstanceID='+InstanceID);
          MyList.Add('PageID=1');
          AResponseInfo.ContentText := GetHtml_Menu(MyList);
          AResponseInfo.ContentType := 'text/html';
          AResponseInfo.CharSet := 'utf-8';
          AContext.Connection.IOHandler.DefAnsiEncoding := IndyUTF8Encoding;
      end;
  end;

  //MySync.Free;


end;

procedure TForm1.IdHTTPServer1CommandOther(AContext: TIdContext;
  ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
begin

end;

procedure TForm1.IdHTTPServer1CreatePostStream(AContext: TIdContext;
  AHeaders: TIdHeaderList; var VPostStream: TStream);
begin
  //如果要接受客户端发过来的流，则在此事件中要写如下代码
  //VPostStream := TMemoryStream.Create;
end;

//https://stackoverflow.com/questions/32733033/how-to-receive-query-string-containing-foreign-characters-in-tidhttpserver
procedure TForm1.DecodeParams(const AValue: String; Params: TStrings);
var
  i, j : Integer;
  s: string;

  // if you are not using Indy 10.6+, you can replace
  // IIdTextEncoding with TIdTextEncoding...
  //
  //LEncoding: TIdTextEncoding;
  LEncoding: IIdTextEncoding;
begin
  // Convert special characters
  // ampersand '&' separates values    {Do not Localize}
  Params.BeginUpdate;
  try
    Params.Clear;

    // if you are not using Indy 10.6+, you can replace
    // IndyTextEncoding_UTF8 with TIdTextEncoding.UTF8...
    //
    //LEncoding := TIdTextEncoding.UTF8;
    LEncoding := IndyTextEncoding_UTF8;

    i := 1;
    while i <= Length(AValue) do
    begin
      j := i;
      while (j <= Length(AValue)) and (AValue[j] <> '&') do {do not localize}
      begin
        Inc(j);
      end;
      s := Copy(AValue, i, j-i);
      // See RFC 1866 section 8.2.1. TP
      s := ReplaceAll(s, '+', ' ');  {do not localize}
      Params.Add(TIdURI.URLDecode(s, LEncoding));
      i := j + 1;
    end;
  finally
    Params.EndUpdate;
  end;
end;

//https://www.e-learn.cn/en/node/2278714
procedure TForm1.MyDecodeAndSetParams(ARequestInfo: TIdHTTPRequestInfo);
var
  i, j : Integer;
  value, s: string;
  LEncoding: IIdTextEncoding;
begin
  {
  if IsHeaderMediaType(ARequestInfo.ContentType, 'application/x-www-form-urlencoded') then
  begin
    value := ARequestInfo.FormParams;
    LEncoding := CharsetToEncoding(ARequestInfo.CharSet);
  end else
  begin
    value := ARequestInfo.QueryParams;
    LEncoding := IndyTextEncoding_UTF8;
  end;
  }
  value := ARequestInfo.QueryParams;
  LEncoding := IndyTextEncoding_UTF8;




  ARequestInfo.Params.BeginUpdate;
  try
    ARequestInfo.Params.Clear;
    i := 1;
    while i <= Length(value) do
    begin
      j := i;
      while (j <= Length(value)) and (value[j] <> '&') do
      begin
        Inc(j);
      end;
      s := StringReplace(Copy(value, i, j-i), '+', ' ', [rfReplaceAll]);
      ARequestInfo.Params.Add(TIdURI.URLDecode(s, LEncoding));
      i := j + 1;
    end;
  finally
    ARequestInfo.Params.EndUpdate;
  end;
end;


procedure TForm1.MenuItem1Click(Sender: TObject);
begin
  Form1.FormStyle:=fsStayOnTop; //沒用 ?
end;

function TForm1.Chk_Login(_usr: String; _pwd:String): boolean;
var rv:boolean;
begin
  rv:=false;

  if (_usr='123') and (_pwd='456') then begin
      rv:=true;
  end;

  result:=rv;
end;



procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  //
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  IdHTTPServer1.Active := False;
  MyIni.WriteInteger('PARAMETER', 'ComboBox1_ItemIndex', ComboBox1.ItemIndex);
  MyIni.WriteString('PARAMETER', 'WIFI_IP', wifi_ip);

  MyList.Free;
  MyIni.Free;

  _SaveLog('○程式結束');

  DeleteCriticalSection(MyCriticalSection); //2019/07/26

end;

//根據登入 ID, 建立使用者菜單
procedure TForm1.MakeUserMenuDataSet(id: String);
begin
  if MemDataset1.Active=false then MemDataset1.Active:=true;
  MemDataset1.Append;
  MemDataset1.FieldByName('InstanceID').AsString:=id;
  MemDataset1.FieldByName('BarcodeID').AsString:='01';
  MemDataset1.FieldByName('PluName').AsString:='浦燒鰻魚';
  MemDataset1.FieldByName('unitPrice').AsInteger:=40;
  MemDataset1.FieldByName('qty').AsInteger:=0;
  MemDataset1.FieldByName('salePrice').AsInteger:=0;
  MemDataset1.Post;
  MemDataset1.Append;
  MemDataset1.FieldByName('InstanceID').AsString:=id;
  MemDataset1.FieldByName('BarcodeID').AsString:='02';
  MemDataset1.FieldByName('PluName').AsString:='甜蝦';
  MemDataset1.FieldByName('unitPrice').AsInteger:=40;
  MemDataset1.FieldByName('qty').AsInteger:=0;
  MemDataset1.FieldByName('salePrice').AsInteger:=0;
  MemDataset1.Post;
  MemDataset1.Append;
  MemDataset1.FieldByName('InstanceID').AsString:=id;
  MemDataset1.FieldByName('BarcodeID').AsString:='03';
  MemDataset1.FieldByName('PluName').AsString:='章魚';
  MemDataset1.FieldByName('unitPrice').AsInteger:=40;
  MemDataset1.FieldByName('qty').AsInteger:=0;
  MemDataset1.FieldByName('salePrice').AsInteger:=0;
  MemDataset1.Post;
  MemDataset1.Append;
  MemDataset1.FieldByName('InstanceID').AsString:=id;
  MemDataset1.FieldByName('BarcodeID').AsString:='04';
  MemDataset1.FieldByName('PluName').AsString:='北寄貝';
  MemDataset1.FieldByName('unitPrice').AsInteger:=40;
  MemDataset1.FieldByName('qty').AsInteger:=0;
  MemDataset1.FieldByName('salePrice').AsInteger:=0;
  MemDataset1.Post;
  MemDataset1.Append;
  MemDataset1.FieldByName('InstanceID').AsString:=id;
  MemDataset1.FieldByName('BarcodeID').AsString:='05';
  MemDataset1.FieldByName('PluName').AsString:='烏賊';
  MemDataset1.FieldByName('unitPrice').AsInteger:=40;
  MemDataset1.FieldByName('qty').AsInteger:=0;
  MemDataset1.FieldByName('salePrice').AsInteger:=0;
  MemDataset1.Post;
  MemDataset1.Append;
  MemDataset1.FieldByName('InstanceID').AsString:=id;
  MemDataset1.FieldByName('BarcodeID').AsString:='06';
  MemDataset1.FieldByName('PluName').AsString:='鮭魚肚';
  MemDataset1.FieldByName('unitPrice').AsInteger:=40;
  MemDataset1.FieldByName('qty').AsInteger:=0;
  MemDataset1.FieldByName('salePrice').AsInteger:=0;
  MemDataset1.Post;
end;

//根據登入 ID, 重置使用者菜單(數量)
procedure TForm1.ResetUserMenuDataSet(id: String);
begin
  if MemDataset1.Active=false then MemDataset1.Active:=true;
  MemDataset1.First;
  while not MemDataset1.Eof do begin
      if Trim(MemDataset1.FieldByName('InstanceID').AsString)<>Trim(id) then begin
           MemDataset1.Next;
           continue;
      end;
      MemDataset1.Edit;
      MemDataset1.FieldByName('qty').AsInteger:=0;
      MemDataset1.FieldByName('saleprice').AsInteger:=0;
      MemDataset1.Post;

      MemDataset1.Next;
  end;
end;

//根據登入 ID, 更新使用者菜單(數量)
procedure TForm1.UpdateUserMenuDataSet(id: String; param: String);
var TmpList:TStringList;
    barcode: String;
begin
  TmpList := TStringList.Create;
  TmpList.Clear;
  TmpList.Text:=param;

  if MemDataset1.Active=false then MemDataset1.Active:=true;
  MemDataset1.First;
  while not MemDataset1.Eof do begin
      if Trim(MemDataset1.FieldByName('InstanceID').AsString)<>Trim(id) then begin
           MemDataset1.Next;
           continue;
      end;

      barcode:=Trim(MemDataset1.FieldByName('BarcodeID').AsString);

      //菜單中選數量
      if (TmpList.Values['D_'+barcode]<>'') then begin
          MemDataset1.Edit;
          MemDataset1.FieldByName('qty').AsInteger:=_StrToInt(TmpList.Values['D_'+barcode]);
          MemDataset1.FieldByName('saleprice').AsInteger:=MemDataset1.FieldByName('unitprice').AsInteger*MemDataset1.FieldByName('qty').AsInteger;
          MemDataset1.Post;
      end;

      //清單中勾選刪除
      if (TmpList.Values['C_'+barcode]='on') then begin
          MemDataset1.Edit;
          MemDataset1.FieldByName('qty').AsInteger:=0;
          MemDataset1.FieldByName('saleprice').AsInteger:=0;
          MemDataset1.Post;
      end;




      //_SaveLog('TmpList.Values[D_'+barcode+']='+TmpList.Values['D_'+barcode]);
      //_SaveLog('TmpList.Values[D_'+barcode+']='+IntToStr(_StrToInt(TmpList.Values['D_'+barcode])));
      //_SaveLog('MemDataset1.FieldByName(qty).AsInteger='+MemDataset1.FieldByName('qty').AsString);


      MemDataset1.Next;
  end;

  TmpList.Free;
end;

//------------------------------------------------------------------------------
procedure TForm1._SaveLog(log: string);
var fn: string;
    now_str: string;
    f:textfile;
    i: integer;
    tmp: String;
begin

  //remark 2019/07/26
  //exit;  //2019/07/25

  {
  //有任何連線進來時, 先將 Log 記錄在 MyList
  if (connection_count<>0) then begin
      now_str:=FormatDateTime('yyyy-mm-dd hh:nn:ss ',Now);
      MyList.Add(now_str+log);
      exit;
  end;
  }

  {
  //remark 2019/07/26
  fn:=MyPath+'Log_'+FormatDateTime('yyyymmdd', Date)+'.log';
  log_fn:=fn;

  if not FileExists(fn) then
  begin
    FileClose(FileCreate(fn));
  end;

  now_str:=FormatDateTime('yyyy-mm-dd hh:nn:ss ',Now);

  AssignFile(f, fn);
  Append(f);
  }

  {
  //寫檔時先將 MyList 暫存內容寫出去
  if (MyList.Count<>0) then begin
    for i:=0 to MyList.Count-1 do begin
      tmp:=MyList.Strings[i];
      WriteLn(f, tmp);
    end;
    MyList.Clear;
  end;
  }

  {
  //remark 2019/07/26
  WriteLn(f, now_str+log);
  CloseFile(f);
  }

  //2019/07/26 ->
  fn:=MyPath+'Log_'+FormatDateTime('yyyymmdd', Date)+'.log';
  log_fn:=fn;
  EnterCriticalSection(MyCriticalSection);
  try
      // access some variables, write files, send some network packets, etc
      if not FileExists(fn) then
      begin
          FileClose(FileCreate(fn));
      end;

      now_str:=FormatDateTime('yyyy-mm-dd hh:nn:ss ',Now);

      AssignFile(f, fn);
      Append(f);
      WriteLn(f, now_str+log);
      CloseFile(f);

  finally
    LeaveCriticalSection(MyCriticalSection);
  end;
  //2019/07/26 <-


end;


function TForm1.GetHtml_Login(param: TStringList): String;
var TmpList:TStringList;
    rv: String;
begin
  rv:='';
  TmpList := TStringList.Create;
  TmpList.Clear;



  TmpList.Add('<html>');

  TmpList.Add('<head>');
  //TmpList.Add('<meta http-equiv="Content-Type" content="text/html; charset=big5">');
  //TmpList.Add('<meta name="GENERATOR" content="Microsoft FrontPage Express 2.0">');

  TmpList.Add('<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">');

  //for 手機版面
  TmpList.Add('<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0" />');

  TmpList.Add('<title>登入作業</title>');
  TmpList.Add('</head>');

  TmpList.Add('<body bgcolor="#FFFFFF">');

  TmpList.Add('<form method="POST">');
  TmpList.Add('    <input type="hidden" name="action" value="login">');
  TmpList.Add('    <p align="center">登入作業</p>');

  //TmpList.Add('    <p align="center">　</p>');
  TmpList.Add('    <p align="center"><img src="login.jpg" width="90" height="90"></p>'); //2019/07/22

  TmpList.Add('    <p align="center">帳號：<input type="text" size="20"');
  TmpList.Add('    name="usr"></p>');
  TmpList.Add('    <p align="center">密碼：<input type="password" size="20"');
  TmpList.Add('    name="pwd"></p>');
  TmpList.Add('    <p align="center"><input type="reset" name="B1"');
  TmpList.Add('    value="重設">　　　<input type="submit" name="B2" value="登入"></p>');
  TmpList.Add('    <p>　</p>');
  TmpList.Add('</form>');
  TmpList.Add('</body>');
  TmpList.Add('</html>');


  rv:=TmpList.Text;
  TmpList.Free;

  result:=rv;

end;


function TForm1.GetHtml_LoginErr(param: TStringList): String;
var TmpList:TStringList;
    rv: String;
begin
  rv:='';
  TmpList := TStringList.Create;
  TmpList.Clear;

  TmpList.Add('<html>');

  TmpList.Add('<head>');

  TmpList.Add('<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">');

  //for 手機版面
  TmpList.Add('<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0" />');

  TmpList.Add('<title>登入失敗</title>');
  TmpList.Add('</head>');

  TmpList.Add('<body bgcolor="#FFFFFF">');

  TmpList.Add('<form method="POST">');
  TmpList.Add('    <p>　</p>');
  TmpList.Add('    <p align="center"><font color="#FF0000">登入錯誤, 帳密失敗 !!</font></p>');
  TmpList.Add('    <p align="center">　</p>');
  TmpList.Add('    <p align="center"><input type="submit" name="B1"');
  TmpList.Add('    value="重新登入"></p>');
  TmpList.Add('    <p>　</p>');
  TmpList.Add('</form>');
  TmpList.Add('</body>');
  TmpList.Add('</html>');


  rv:=TmpList.Text;
  TmpList.Free;

  result:=rv;

end;

function TForm1.GetHtml_Menu(param: TStringList): String;
var TmpList:TStringList;
    rv: String;
    i: integer;
    InstanceID: String;
    PageID: integer;
    jpg_fn: String;
begin
  rv:='';

  _SaveLog('Call GetHtml_Menu() Start...');

  InstanceID:=param.Values['InstanceID'];   //登入 InstanceID
  PageID:=_StrToInt(param.Values['PageID']); //頁次

  _SaveLog('InstanceID='+InstanceID);
  _SaveLog('PageID='+IntToStr(PageID));

  TmpList := TStringList.Create;
  TmpList.Clear;

  TmpList.Add('<html>');

  TmpList.Add('<head>');

  TmpList.Add('<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">');

  //for 手機版面
  TmpList.Add('<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0" />');

  TmpList.Add('<title>菜單選擇</title>');
  TmpList.Add('</head>');

  TmpList.Add('<body bgcolor="#FFFFFF">');
  TmpList.Add('<form method="POST">');

  TmpList.Add('    <input type="hidden" name="InstanceID" value="'+InstanceID+'">');
  TmpList.Add('    <input type="hidden" name="action" value="menu">');
  TmpList.Add('    <input type="hidden" name="PageID" value='+IntToStr(PageID)+'>');
  TmpList.Add('    <p align="center">分類：<select name="DD1" size="1">');
  TmpList.Add('        <option selected>壽司</option>');
  TmpList.Add('        <option>套餐</option>');
  TmpList.Add('    </select>　　桌號：<select name="DD2" size="1">');
  TmpList.Add('        <option>1</option>');
  TmpList.Add('        <option>2</option>');
  TmpList.Add('        <option>3</option>');
  TmpList.Add('        <option>4</option>');
  TmpList.Add('        <option>5</option>');
  TmpList.Add('    </select>　　序：</p>');


  TmpList.Add('    <div align="center"><center><table border="0">');
  TmpList.Add('        <tr>');
  TmpList.Add('            <td>商品</td>');
  TmpList.Add('            <td>ID</td>');    //2019/07/22
  TmpList.Add('            <td>名稱</td>');
  TmpList.Add('            <td>單價</td>');
  TmpList.Add('            <td>數量</td>');
  TmpList.Add('        </tr>');


  //建立菜單
  if MemDataset1.Active=false then MemDataset1.Active:=true;
  MemDataset1.First;
  while not MemDataset1.Eof do begin
       if Trim(MemDataset1.FieldByName('InstanceID').AsString)<>Trim(InstanceID) then begin
           MemDataset1.Next;
           continue;
       end;

       TmpList.Add('        <tr>');

       //2019/07/22 ->
       jpg_fn:=MemDataset1.FieldByName('BarcodeID').AsString+'.jpg';
       if (FileExists(jpg_fn)) then begin
           TmpList.Add('            <td><img src="'+jpg_fn+'" width="90" height="55"></td>');
       end else begin
           TmpList.Add('            <td>　</td>');
       end;
       //2019/07/22 <-

       TmpList.Add('            <td>'+MemDataset1.FieldByName('BarcodeID').AsString+'</td>');
       TmpList.Add('            <td>'+MemDataset1.FieldByName('PluName').AsString+'</td>');
       TmpList.Add('            <td>'+MemDataset1.FieldByName('unitPrice').AsString+'</td>');
       TmpList.Add('            <td><select name="D_'+MemDataset1.FieldByName('BarcodeID').AsString+'" size="1">');
       TmpList.Add(GetSubHtml_ComboxItem(0, 10, MemDataset1.FieldByName('qty').AsInteger));
       TmpList.Add('            </select></td>');
       TmpList.Add('        </tr>');


       MemDataset1.Next;
  end;





  TmpList.Add('    </table>');
  TmpList.Add('    </center></div>');
  TmpList.Add('    <p align="center">');
  TmpList.Add('    <input type="submit" name="B1" value="菜單上頁" action2="pgup">');
  TmpList.Add('    <input type="submit" name="B2" value="菜單下頁" action2="pgdn">');

  TmpList.Add('    <p align="center">');
  TmpList.Add('    <input type="submit" name="B3" value="交易取消" action2="cancel">');
  TmpList.Add('    <input type="submit" name="B4" value="清單小計" action2="total_list">');
  TmpList.Add('    <p align="center">　</p>');
  TmpList.Add('    <p align="center">　</p>');
  TmpList.Add('</form>');

  TmpList.Add('<p>　</p>');
  TmpList.Add('</body>');
  TmpList.Add('</html>');



  rv:=TmpList.Text;
  TmpList.Free;

  //_SaveLog(rv);
  _SaveLog('Call GetHtml_Menu() End');

  result:=rv;

end;

function TForm1.GetHtml_SubTotal(param: TStringList): String;
var TmpList:TStringList;
    rv: String;
    i: integer;
    InstanceID: String;
    tot_amt: Integer;
begin
  rv:='';

  _SaveLog('Call GetHtml_SubTotal() Start...');

  InstanceID:=param.Values['InstanceID'];   //登入 InstanceID

  TmpList := TStringList.Create;
  TmpList.Clear;

  TmpList.Add('<html>');

  TmpList.Add('<head>');

  TmpList.Add('<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">');

  //for 手機版面
  TmpList.Add('<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0" />');

  TmpList.Add('<title>菜單選擇</title>');

  //2019/07/19 ->
  TmpList.Add('<script type="text/javascript">');
  TmpList.Add('  function _QueryBox(msg)');
  TmpList.Add('  {');
  TmpList.Add('    return confirm(msg);');
  TmpList.Add('  }');
  TmpList.Add('</script>');
  //2019/07/19 <-


  TmpList.Add('</head>');

  TmpList.Add('<body bgcolor="#FFFFFF">');

  TmpList.Add('<form method="POST">');

  TmpList.Add('    <input type="hidden" name="InstanceID" value="'+InstanceID+'">');
  TmpList.Add('    <input type="hidden" name="action" value="subtotal">');
  TmpList.Add('    <p align="center">分類：<select name="DD1" size="1">');
  TmpList.Add('        <option selected>壽司</option>');
  TmpList.Add('        <option>套餐</option>');
  TmpList.Add('    </select>　　桌號：<select name="DD2" size="1">');
  TmpList.Add('        <option>1</option>');
  TmpList.Add('        <option>2</option>');
  TmpList.Add('        <option>3</option>');
  TmpList.Add('        <option>4</option>');
  TmpList.Add('        <option>5</option>');
  TmpList.Add('    </select>　　序：</p>');

  TmpList.Add('    <div align="center"><center><table border="0">');
  TmpList.Add('    <tr>');
  TmpList.Add('        <td>刪除</td>');
  TmpList.Add('        <td>商品</td>');
  TmpList.Add('        <td>名稱</td>');
  TmpList.Add('        <td>數量</td>');
  TmpList.Add('        <td>金額</td>');
  TmpList.Add('        <td>特殊需求</td>');
  TmpList.Add('    </tr>');






  //建立清單
  tot_amt:=0;
  if MemDataset1.Active=false then MemDataset1.Active:=true;
  MemDataset1.First;
  while not MemDataset1.Eof do begin
       if Trim(MemDataset1.FieldByName('InstanceID').AsString)<>Trim(InstanceID) then begin
           MemDataset1.Next;
           continue;
       end;

       if (MemDataset1.FieldByName('qty').AsInteger=0) then begin
           MemDataset1.Next;
           continue;
       end;

       TmpList.Add('        <tr>');
       TmpList.Add('            <td><input type="checkbox" name="C_'+MemDataset1.FieldByName('BarcodeID').AsString+'"></td>');
       TmpList.Add('            <td>'+MemDataset1.FieldByName('BarcodeID').AsString+'</td>');
       TmpList.Add('            <td>'+MemDataset1.FieldByName('PluName').AsString+'</td>');
       TmpList.Add('            <td>'+MemDataset1.FieldByName('qty').AsString+'</td>');
       TmpList.Add('            <td>'+MemDataset1.FieldByName('salePrice').AsString+'</td>');
       TmpList.Add('            <td>  </td>');
       TmpList.Add('        </tr>');

       tot_amt:=tot_amt+MemDataset1.FieldByName('salePrice').AsInteger;

       MemDataset1.Next;
  end;




  TmpList.Add('    </table>');
  TmpList.Add('    </center></div><p align="center">');
  TmpList.Add('    <input type="submit" name="B1" value="小計：'+IntToStr(tot_amt)+'"');
  TmpList.Add('    <p align="center">　</p>');
  TmpList.Add('    <p align="center">　</p>');
  TmpList.Add('    <p align="center">');
  TmpList.Add('    <input type="submit" name="B2" value="繼續點餐">　');
  TmpList.Add('    <input type="submit" name="B3" value="交易取消" onclick="return _QueryBox(''是否確認[交易取消]'')">　');
  TmpList.Add('    <input type="submit" name="B4" value="結帳完成" onclick="return _QueryBox(''是否確認[結帳完成]'')">');
  TmpList.Add('    </p>');
  TmpList.Add('    <p align="center">　</p>');
  TmpList.Add('    <p align="center">　</p>');
  TmpList.Add('</form>');

  TmpList.Add('<p>　</p>');
  TmpList.Add('</body>');
  TmpList.Add('</html>');




  rv:=TmpList.Text;
  TmpList.Free;

  _SaveLog(rv);
  _SaveLog('Call GetHtml_SubTotal() End');

  result:=rv;


end;

function TForm1.GetSubHtml_ComboxItem(_from: integer; _to: integer; select_id: integer): String;
var TmpList:TStringList;
    rv: String;
    i: integer;
begin
  rv:='';
  TmpList := TStringList.Create;
  TmpList.Clear;

  for i:=_from to _to do begin
       if i=select_id then begin
           TmpList.Add('                <option selected>'+IntToStr(i)+'</option>');
       end else begin
           TmpList.Add('                <option>'+IntToStr(i)+'</option>');
       end;
  end;

  rv:=TmpList.Text;
  TmpList.Free;

  result:=rv;
end;

function  TForm1._StrToInt(Str:String): integer;
var rv: integer;
begin
  rv:=0;
  try
    rv:=StrToInt(Str);
  except
    ;;
  end;

  result:=rv;
end;

function TForm1._Right(Str:String ; n:integer): String;
var r:String;
begin
  r:='';
  if (n>Length(Str)) then
     begin
       result:=Str;
       exit;
     end;

  r:=Copy(Str,Length(Str)-n+1,n);

  result:=r;

end;

function TForm1._Left(str: String; len: integer):String;
var tmp,tmp2:String;
begin
 {
 tmp:=UTF8ToAnsi(str);
 tmp2:=Copy(tmp,1,len);
 result:=AnsiToUTF8(tmp2);
 }

 if len=0 then result:='';

 result:=Copy(str, 1, len);

end;


function TForm1._CutLeft(str: String; len: integer): String;
var r:String;
begin
  r:='';
  if (len>Length(str)) then
     begin
       result:=r;
       exit;
     end;

  r:=Copy(str, len+1, Length(str)-len);

  result:=r;
end;


end.

